var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var index_exports = {};
__export(index_exports, {
  ApiProxyConnector: () => APIProxyConnector,
  default: () => index_default
});
module.exports = __toCommonJS(index_exports);

// src/handlers/search/index.ts
var import_sdk = __toESM(require("@searchkit/sdk"));

// src/handlers/SearchkitModule.ts
var SearchkitSDK = __toESM(require("@searchkit/sdk"));
var SearchkitModule_default = typeof SearchkitSDK.default === "object" ? SearchkitSDK.default : SearchkitSDK;

// src/version.ts
var LIB_VERSION = "1.23.0";

// src/handlers/search/Configuration.ts
var {
  Filter: SKFilter,
  GeoDistanceOptionsFacet,
  MultiMatchQuery,
  MultiQueryOptionsFacet,
  RefinementSelectFacet
} = SearchkitModule_default;
function getResultFields(resultFields) {
  const hitFields = Object.keys(resultFields);
  const highlightFields = Object.keys(resultFields).reduce((acc, fieldKey) => {
    const fieldConfiguration = resultFields[fieldKey];
    if (fieldConfiguration.snippet) {
      acc.push(fieldKey);
    }
    return acc;
  }, []);
  return { hitFields, highlightFields };
}
function getQueryFields(searchFields = {}) {
  return Object.keys(searchFields).map((fieldKey) => {
    const fieldConfiguration = searchFields[fieldKey];
    const weight = `^${fieldConfiguration.weight || 1}`;
    return fieldKey + weight;
  });
}
var elasticRelativeDateRegex = /^(?:now|\d{4}-\d{2}-\d{2}(?:T\d{2}:\d{2}:\d{2}(?:\.\d+)?Z?)?\|\|)(?:[+-]\d[yMwdhHms])?(?:\/[yMwdhHms])?$/;
function isDateMathString(dateString) {
  if (dateString.match(elasticRelativeDateRegex)) {
    return true;
  }
  return false;
}
function isValidDateString(dateString) {
  return typeof dateString === "string" && (isDateMathString(dateString) || !isNaN(Date.parse(dateString)));
}
function isRangeFilter(filterValue) {
  return typeof filterValue === "object" && ("from" in filterValue || "to" in filterValue);
}
function getSortOptionByState(state) {
  var _a;
  if (((_a = state.sortList) == null ? void 0 : _a.length) > 0) {
    return "selectedOption" /* SelectedOption */;
  } else if (state.sortField && state.sortDirection) {
    return "customOption" /* CustomOption */;
  } else {
    return null;
  }
}
function buildBaseFilters(baseFilters) {
  const filters = (baseFilters || []).reduce((acc, filter) => {
    const boolType = {
      all: "filter",
      any: "should",
      none: "must_not"
    }[filter.type];
    return [
      ...acc,
      {
        bool: {
          [boolType]: filter.values.map((value) => {
            if (isRangeFilter(value)) {
              return {
                range: {
                  [filter.field]: __spreadValues(__spreadValues({}, "from" in value ? {
                    from: isValidDateString(value.from) ? value.from : Number(value.from)
                  } : {}), "to" in value ? {
                    to: isValidDateString(value.to) ? value.to : Number(value.to)
                  } : {})
                }
              };
            }
            return {
              term: {
                [filter.field]: value
              }
            };
          })
        }
      }
    ];
  }, []);
  return filters;
}
function buildConfiguration({
  state,
  queryConfig,
  cloud,
  host,
  index,
  apiKey,
  headers,
  postProcessRequestBodyFn
}) {
  var _a;
  const { hitFields, highlightFields } = getResultFields(
    queryConfig.result_fields
  );
  const queryFields = getQueryFields(queryConfig.search_fields);
  const filtersConfig = Object.values(
    (state.filters || []).filter((f) => !queryConfig.facets[f.field]).reduce((acc, f) => {
      return __spreadProps(__spreadValues({}, acc), {
        [f.field]: new SKFilter({
          field: f.field,
          identifier: f.field,
          label: f.field
        })
      });
    }, {})
  );
  const facets = Object.keys(queryConfig.facets || {}).reduce(
    (acc, facetKey) => {
      var _a2;
      const facetConfiguration = queryConfig.facets[facetKey];
      const isDisJunctive = (_a2 = queryConfig.disjunctiveFacets) == null ? void 0 : _a2.includes(facetKey);
      if (facetConfiguration.type === "value") {
        acc.push(
          new RefinementSelectFacet({
            identifier: facetKey,
            field: facetKey,
            label: facetKey,
            size: facetConfiguration.size || 20,
            multipleSelect: isDisJunctive,
            order: facetConfiguration.sort || "count"
          })
        );
      } else if (facetConfiguration.type === "range" && !facetConfiguration.center) {
        acc.push(
          new MultiQueryOptionsFacet({
            identifier: facetKey,
            field: facetKey,
            label: facetKey,
            multipleSelect: isDisJunctive,
            options: facetConfiguration.ranges.map((range) => {
              return __spreadValues(__spreadValues(__spreadValues(__spreadValues({
                label: range.name
              }, typeof range.from === "number" ? { min: range.from } : {}), typeof range.to === "number" ? { max: range.to } : {}), isValidDateString(range.from) ? { dateMin: range.from.toString() } : {}), isValidDateString(range.to) ? { dateMax: range.to.toString() } : {});
            })
          })
        );
      } else if (facetConfiguration.type === "range" && facetConfiguration.center) {
        acc.push(
          new GeoDistanceOptionsFacet({
            identifier: facetKey,
            field: facetKey,
            label: facetKey,
            multipleSelect: isDisJunctive,
            origin: facetConfiguration.center,
            unit: facetConfiguration.unit,
            ranges: facetConfiguration.ranges.map((range) => {
              return __spreadValues(__spreadValues({
                label: range.name
              }, range.from ? { from: Number(range.from) } : {}), range.to ? { to: Number(range.to) } : {});
            })
          })
        );
      }
      return acc;
    },
    []
  );
  const sortOptions = [
    {
      id: "selectedOption" /* SelectedOption */,
      label: "selectedOption" /* SelectedOption */,
      field: ((_a = state.sortList) == null ? void 0 : _a.length) > 0 ? state.sortList.reduce((acc, s) => {
        acc.push({
          [s.field]: s.direction
        });
        return acc;
      }, []) : "_score"
    }
  ];
  if (state.sortField && state.sortDirection) {
    sortOptions.push({
      id: "customOption" /* CustomOption */,
      label: "customOption" /* CustomOption */,
      field: [{ [state.sortField]: state.sortDirection }]
    });
  }
  const jsVersion = typeof window !== "undefined" ? "browser" : process.version;
  const metaHeader = `ent=${LIB_VERSION}-es-connector,js=${jsVersion},t=${LIB_VERSION}-es-connector,ft=universal`;
  const wrappedPostProcessRequestFn = postProcessRequestBodyFn ? (body) => {
    return postProcessRequestBodyFn(body, state, queryConfig);
  } : null;
  const additionalHeaders = headers || {};
  const configuration = {
    host,
    cloud,
    index,
    connectionOptions: {
      apiKey,
      headers: __spreadProps(__spreadValues({}, additionalHeaders), {
        "x-elastic-client-meta": metaHeader
      })
    },
    hits: {
      fields: hitFields,
      highlightedFields: highlightFields
    },
    query: new MultiMatchQuery({
      fields: queryFields
    }),
    sortOptions,
    facets,
    filters: filtersConfig,
    postProcessRequest: wrappedPostProcessRequestFn
  };
  return configuration;
}
var Configuration_default = buildConfiguration;

// src/handlers/search/Request.ts
var import_search_ui = require("@elastic/search-ui");
function getFilters(filters = [], baseFilters = []) {
  return filters.reduce((acc, f) => {
    const isBaseFilter = baseFilters.find((base) => base.field === f.field);
    if (isBaseFilter) return acc;
    const subFilters = f.values.map((v) => {
      if (import_search_ui.helpers.isFilterValueRange(v)) {
        return __spreadValues(__spreadValues({
          identifier: f.field
        }, isValidDateString(v.from) ? { dateMin: v.from } : { min: v.from }), isValidDateString(v.to) ? { dateMax: v.to } : { max: v.to });
      }
      return {
        identifier: f.field,
        value: v
      };
    });
    return [...acc, ...subFilters];
  }, []);
}
function SearchRequest(state, queryConfig) {
  return {
    query: state.searchTerm,
    filters: state.filters ? getFilters(state.filters, queryConfig.filters) : [],
    from: (state.current - 1) * state.resultsPerPage,
    size: state.resultsPerPage,
    sort: getSortOptionByState(state)
  };
}
var Request_default = SearchRequest;

// src/handlers/common.ts
function fieldResponseMapper(item) {
  const fields = item.fields;
  const highlights = item.highlight || {};
  const combinedFieldKeys = [
    ...new Set(Object.keys(fields).concat(Object.keys(highlights)))
  ];
  return combinedFieldKeys.reduce(
    (acc, key) => {
      return __spreadProps(__spreadValues({}, acc), {
        [key]: __spreadValues(__spreadValues({}, key in fields ? { raw: fields[key] } : {}), key in highlights ? { snippet: highlights[key] } : {})
      });
    },
    {
      id: { raw: item.id },
      _meta: {
        id: item.rawHit._id,
        rawHit: item.rawHit
      }
    }
  );
}

// src/handlers/search/Response.ts
function SearchResponse(results) {
  const facets = (results.facets || []).reduce((acc, facet) => {
    return __spreadProps(__spreadValues({}, acc), {
      [facet.identifier]: [
        {
          data: facet.entries.map((e) => ({
            value: e.label,
            count: e.count
          })),
          type: "value"
        }
      ]
    });
  }, {});
  const pageEnd = (results.hits.page.pageNumber + 1) * results.hits.page.size;
  const response = {
    resultSearchTerm: results.summary.query,
    totalPages: results.hits.page.totalPages,
    pagingStart: results.summary.total && results.hits.page.pageNumber * results.hits.page.size + 1,
    pagingEnd: pageEnd > results.summary.total ? results.summary.total : pageEnd,
    wasSearched: false,
    totalResults: results.summary.total,
    facets,
    results: results.hits.items.map(fieldResponseMapper),
    requestId: null,
    rawResponse: null
  };
  return response;
}
var Response_default = SearchResponse;

// src/handlers/search/index.ts
var Searchkit = import_sdk.default.default || import_sdk.default;
function handleRequest(configuration) {
  return __async(this, null, function* () {
    const {
      state,
      queryConfig,
      host,
      cloud,
      index,
      connectionOptions,
      postProcessRequestBodyFn
    } = configuration;
    const { apiKey, headers } = connectionOptions || {};
    const searchkitConfig = Configuration_default({
      state,
      queryConfig,
      cloud,
      host,
      index,
      apiKey,
      headers,
      postProcessRequestBodyFn
    });
    const request = Searchkit(searchkitConfig);
    const searchkitVariables = Request_default(state, queryConfig);
    const baseFilters = buildBaseFilters(queryConfig.filters);
    const results = yield request.query(searchkitVariables.query).setFilters(searchkitVariables.filters).setSortBy(searchkitVariables.sort).execute(
      {
        facets: queryConfig.facets && Object.keys(queryConfig.facets).length > 0,
        hits: {
          from: searchkitVariables.from,
          size: searchkitVariables.size,
          includeRawHit: true
        }
      },
      baseFilters
    );
    return Response_default(results);
  });
}

// src/handlers/autocomplete/index.ts
var {
  default: Searchkit2,
  CompletionSuggester,
  HitsSuggestor,
  PrefixQuery
} = SearchkitModule_default;
function handleRequest2(configuration) {
  return __async(this, null, function* () {
    const { state, queryConfig, host, cloud, index, connectionOptions } = configuration;
    const { apiKey, headers } = connectionOptions || {};
    const suggestionConfigurations = [];
    if (queryConfig.results) {
      const { hitFields, highlightFields } = getResultFields(
        queryConfig.results.result_fields
      );
      const queryFields = getQueryFields(queryConfig.results.search_fields);
      suggestionConfigurations.push(
        new HitsSuggestor({
          identifier: "hits-suggestions",
          hits: {
            fields: hitFields,
            highlightedFields: highlightFields
          },
          query: new PrefixQuery({ fields: queryFields }),
          size: queryConfig.results.resultsPerPage || 5
        })
      );
    }
    if (queryConfig.suggestions && queryConfig.suggestions.types) {
      const configs = Object.keys(queryConfig.suggestions.types).map((type) => {
        const configuration2 = queryConfig.suggestions.types[type];
        const suggestionsSize = queryConfig.suggestions.size || 5;
        if (configuration2.queryType === "results") {
          const { hitFields, highlightFields } = getResultFields(
            configuration2.result_fields
          );
          const queryFields = getQueryFields(configuration2.search_fields);
          return new HitsSuggestor({
            identifier: `suggestions-hits-${type}`,
            index: configuration2.index,
            hits: {
              fields: hitFields,
              highlightedFields: highlightFields
            },
            query: new PrefixQuery({ fields: queryFields }),
            size: suggestionsSize
          });
        } else if (!configuration2.queryType || configuration2.queryType === "suggestions") {
          const { fields } = configuration2;
          return new CompletionSuggester({
            identifier: `suggestions-completion-${type}`,
            field: fields[0],
            size: suggestionsSize
          });
        }
      });
      suggestionConfigurations.push(...configs);
    }
    const searchkitConfig = {
      host,
      cloud,
      index,
      connectionOptions: {
        apiKey,
        headers
      },
      suggestions: suggestionConfigurations
    };
    const response = yield Searchkit2(searchkitConfig).executeSuggestions(
      state.searchTerm
    );
    const results = response.reduce(
      (acc, suggestion) => {
        const { identifier } = suggestion;
        if (identifier === "hits-suggestions") {
          return __spreadProps(__spreadValues({}, acc), {
            autocompletedResults: suggestion.hits.map(fieldResponseMapper)
          });
        } else if (identifier.startsWith("suggestions-completion-")) {
          const name = identifier.replace("suggestions-completion-", "");
          return __spreadProps(__spreadValues({}, acc), {
            autocompletedSuggestions: __spreadProps(__spreadValues({}, acc.autocompletedSuggestions), {
              [name]: suggestion.suggestions.map((suggestion2) => {
                return {
                  suggestion: suggestion2
                };
              })
            })
          });
        } else if (identifier.startsWith("suggestions-hits-")) {
          const name = identifier.replace("suggestions-hits-", "");
          const config = queryConfig.suggestions.types[name];
          return __spreadProps(__spreadValues({}, acc), {
            autocompletedSuggestions: __spreadProps(__spreadValues({}, acc.autocompletedSuggestions), {
              [name]: suggestion.hits.map((hit) => ({
                queryType: config.queryType,
                result: fieldResponseMapper(hit)
              }))
            })
          });
        }
      },
      {
        autocompletedSuggestions: {}
      }
    );
    return results;
  });
}

// src/connectors/ElasticsearchAPIConnector.ts
var ElasticsearchAPIConnector = class {
  constructor(config, postProcessRequestBodyFn) {
    this.config = config;
    this.postProcessRequestBodyFn = postProcessRequestBodyFn;
    if (!config.host && !config.cloud) {
      throw new Error("Either host or cloud configuration must be provided");
    }
  }
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onResultClick() {
  }
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onAutocompleteResultClick() {
  }
  onSearch(state, queryConfig) {
    return __async(this, null, function* () {
      var _a;
      return handleRequest({
        state,
        queryConfig,
        cloud: this.config.cloud,
        host: this.config.host,
        index: this.config.index,
        connectionOptions: {
          apiKey: this.config.apiKey,
          headers: (_a = this.config.connectionOptions) == null ? void 0 : _a.headers
        },
        postProcessRequestBodyFn: this.postProcessRequestBodyFn
      });
    });
  }
  onAutocomplete(state, queryConfig) {
    return __async(this, null, function* () {
      var _a;
      return handleRequest2({
        state,
        queryConfig,
        cloud: this.config.cloud,
        host: this.config.host,
        index: this.config.index,
        connectionOptions: {
          apiKey: this.config.apiKey,
          headers: (_a = this.config.connectionOptions) == null ? void 0 : _a.headers
        }
      });
    });
  }
};

// src/connectors/ApiProxyConnector.ts
var APIProxyConnector = class {
  constructor({
    basePath = "/api",
    fetchOptions = {}
  } = {}) {
    this.basePath = basePath;
    this.fetchOptions = fetchOptions;
  }
  request(endpoint, body) {
    return __async(this, null, function* () {
      const response = yield fetch(`${this.basePath}${endpoint}`, __spreadProps(__spreadValues({
        method: "POST",
        headers: __spreadValues({
          "Content-Type": "application/json"
        }, this.fetchOptions.headers)
      }, this.fetchOptions), {
        body: JSON.stringify(body)
      }));
      if (!response.ok) {
        throw new Error(
          `APIProxyConnector request failed: ${response.statusText}`
        );
      }
      return response.json();
    });
  }
  onSearch(state, queryConfig) {
    return __async(this, null, function* () {
      return this.request("/search", {
        state,
        queryConfig
      });
    });
  }
  onAutocomplete(state, queryConfig) {
    return __async(this, null, function* () {
      return this.request("/autocomplete", {
        state,
        queryConfig
      });
    });
  }
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onResultClick() {
  }
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onAutocompleteResultClick() {
  }
};

// src/index.ts
var index_default = ElasticsearchAPIConnector;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ApiProxyConnector
});
//# sourceMappingURL=index.js.map